-- プラグイン情報
function getClientInfo()
  return {
    name = "選択ノートのlab（あいうえお）を出力する",
    category = "エクスポート",
    author = "水っぽいスープ",
    versionNumber = 1,
    minEditorVersion = 65540
  }
end


-- メイン関数
function main()

  local flag = SV:getMainEditor():getSelection():hasSelectedNotes()
  if flag == true then

  local Filepath = SV:getProject():getFileName()

  if Filepath ~= "" then

-- 自作ダイアログの中身
    local myForm = {
      title = "選択トラックの.lab（あいうえお）を出力",
    message = "アルファベットのみでお願いします。",
      buttons = "OkCancel",
      widgets = {

        {
          name = "tb1", type = "TextBox",
          label = "保存する名前",
          default = "noname"
        }

      }
    }

-- ダイアログ表示
    local result = SV:showCustomDialog(myForm)

    local filedir = string.match(Filepath, ".+\\")

    local filename = filedir .. tostring(result.answers.tb1) .. ".lab"

    if result.status then

      if not file_exists(filename) or SV:showOkCancelBox("注意", "ファイルが既にあります。上書きしてよいですか？\n" .. filename) then

        local labtext = ""


 -- local Notes = SV:getMainEditor():getSelection():getSelectedNotes();
    local Notes = SV:getMainEditor():getSelection():getSelectedNotes()

-- 配列の要素の数を数える
    NumNotes = 0
    for key in pairs(Notes) do
      NumNotes = NumNotes + 1
    end

    temp_sec=0
    temp_flag = 0
    local start = Notes[1]:getOnset()
    local offset_sec = SV:getProject():getTimeAxis():getSecondsFromBlick(start)*10000000

    for i=1, NumNotes do

      local start = Notes[i]:getOnset()

      local stop = Notes[i]:getEnd()
      local lyric = Notes[i]:getLyrics()

      local boin = ""

      if string.find(lyric, "ぁ") or string.find(lyric, "ァ") or string.find(lyric, "ゃ") or string.find(lyric, "ャ") or string.find(lyric, "a") then
         boin = "a"
      elseif string.find(lyric, "ぃ") or string.find(lyric, "ィ") or string.find(lyric, "i") then
         boin = "i"
      elseif string.find(lyric, "ぅ") or string.find(lyric, "ゥ") or string.find(lyric, "ゅ") or string.find(lyric, "ュ") or string.find(lyric, "u") then
         boin = "u"
      elseif string.find(lyric, "ぇ") or string.find(lyric, "ェ") or string.find(lyric, "e") then
         boin = "e"
      elseif string.find(lyric, "ぉ") or string.find(lyric, "ォ") or string.find(lyric, "ょ") or string.find(lyric, "ョ") or string.find(lyric, "o") then
         boin = "o"

-- 母音
      elseif string.find(lyric, "あ") or string.find(lyric, "か") or string.find(lyric, "が") or string.find(lyric, "さ") or string.find(lyric, "ざ")  or string.find(lyric, "た") or string.find(lyric, "だ") or string.find(lyric, "な") or string.find(lyric, "は") or string.find(lyric, "ば") or string.find(lyric, "ぱ") or string.find(lyric, "ま") or string.find(lyric, "や") or string.find(lyric, "ら") or string.find(lyric, "わ") or string.find(lyric, "ア") or string.find(lyric, "カ") or string.find(lyric, "ガ") or string.find(lyric, "サ") or string.find(lyric, "ザ")  or string.find(lyric, "タ") or string.find(lyric, "ダ") or string.find(lyric, "ナ") or string.find(lyric, "ハ") or string.find(lyric, "バ") or string.find(lyric, "パ") or string.find(lyric, "マ") or string.find(lyric, "ヤ") or string.find(lyric, "ラ") or string.find(lyric, "ワ")  then
         boin = "a"

      elseif string.find(lyric, "い") or string.find(lyric, "き") or string.find(lyric, "ぎ") or string.find(lyric, "し") or string.find(lyric, "じ")  or string.find(lyric, "ち") or string.find(lyric, "ぢ") or string.find(lyric, "に") or string.find(lyric, "ひ") or string.find(lyric, "び") or string.find(lyric, "ぴ") or string.find(lyric, "み") or string.find(lyric, "り") or string.find(lyric, "イ") or string.find(lyric, "キ") or string.find(lyric, "ギ") or string.find(lyric, "シ") or string.find(lyric, "ジ")  or string.find(lyric, "チ") or string.find(lyric, "ヂ") or string.find(lyric, "ニ") or string.find(lyric, "ヒ") or string.find(lyric, "ビ") or string.find(lyric, "ピ") or string.find(lyric, "ミ") or string.find(lyric, "リ") then
         boin = "i"

      elseif string.find(lyric, "う") or string.find(lyric, "く") or string.find(lyric, "ぐ") or string.find(lyric, "す") or string.find(lyric, "ず")  or string.find(lyric, "つ") or string.find(lyric, "づ") or string.find(lyric, "ぬ") or string.find(lyric, "ふ") or string.find(lyric, "ぶ") or string.find(lyric, "ぷ") or string.find(lyric, "む") or string.find(lyric, "ゆ") or string.find(lyric, "る") or string.find(lyric, "ウ") or string.find(lyric, "ク") or string.find(lyric, "グ") or string.find(lyric, "ス") or string.find(lyric, "ズ")  or string.find(lyric, "ツ") or string.find(lyric, "ヅ") or string.find(lyric, "ヌ") or string.find(lyric, "フ") or string.find(lyric, "ブ") or string.find(lyric, "プ") or string.find(lyric, "ム") or string.find(lyric, "ユ") or string.find(lyric, "ル") then
         boin = "u"

      elseif string.find(lyric, "え") or string.find(lyric, "け") or string.find(lyric, "げ") or string.find(lyric, "せ") or string.find(lyric, "ぜ")  or string.find(lyric, "て") or string.find(lyric, "で") or string.find(lyric, "ね") or string.find(lyric, "へ") or string.find(lyric, "べ") or string.find(lyric, "ぺ") or string.find(lyric, "め") or string.find(lyric, "れ") or string.find(lyric, "エ") or string.find(lyric, "ケ") or string.find(lyric, "ゲ") or string.find(lyric, "セ") or string.find(lyric, "ゼ")  or string.find(lyric, "テ") or string.find(lyric, "デ") or string.find(lyric, "ネ") or string.find(lyric, "ヘ") or string.find(lyric, "ベ") or string.find(lyric, "ペ") or string.find(lyric, "メ") or string.find(lyric, "レ") then
         boin = "e"

      elseif string.find(lyric, "お") or string.find(lyric, "こ") or string.find(lyric, "ご") or string.find(lyric, "そ") or string.find(lyric, "ぞ")  or string.find(lyric, "と") or string.find(lyric, "ど") or string.find(lyric, "の") or string.find(lyric, "ほ") or string.find(lyric, "ぼ") or string.find(lyric, "ぽ") or string.find(lyric, "も") or string.find(lyric, "よ") or string.find(lyric, "ろ") or string.find(lyric, "オ") or string.find(lyric, "コ") or string.find(lyric, "ゴ") or string.find(lyric, "ソ") or string.find(lyric, "ゾ")  or string.find(lyric, "ト") or string.find(lyric, "ド") or string.find(lyric, "ノ") or string.find(lyric, "ホ") or string.find(lyric, "ボ") or string.find(lyric, "ポ") or string.find(lyric, "モ") or string.find(lyric, "ヨ") or string.find(lyric, "ロ") then
         boin = "o"

-- ん
      elseif  string.find(lyric, "ん") or string.find(lyric,"ン") or string.find(lyric, "n") then
         boin = "n"

-- 変換できない
      else
         boin = "pau"
      end

      local start_sec = SV:getProject():getTimeAxis():getSecondsFromBlick(start)*10000000 - offset_sec
      local stop_sec = SV:getProject():getTimeAxis():getSecondsFromBlick(stop)*10000000 - offset_sec

      if start_sec ~= temp_sec and temp_flag ~= 0 then
        labtext = labtext .. math.floor(temp_sec) .. " " .. math.floor(start_sec) .. " pau\n"
      end

      labtext = labtext .. math.floor(start_sec) .. " " .. math.floor(stop_sec) .. " " .. boin .. "\n"
      temp_sec=stop_sec
      temp_flag = 1
    end


      io.output(filename)
      io.write(labtext)

       SV:showMessageBox("保存完了","ファイル名 "  .. filename .. " で保存しました。 ")
    end
    end
  else
      SV:showMessageBox("注意","SynthVのファイルを先に保存してください。")
  end

  else
	SV:showMessageBox("注意","ノートを選択してください")
  end
-- スクリプト終了
  SV:finish()
end


-- ファイルの有無チェック
function file_exists(file)
	local result = false 
	local fh = io.open(file, "rb")
	if nil ~= fh then
		fh:close(fh)
		result = true
	end
	return result
end